"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _chokidar() {
  const data = _interopRequireDefault(require("chokidar"));

  _chokidar = function () {
    return data;
  };

  return data;
}

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _build() {
  const data = require("../lib/build");

  _build = function () {
    return data;
  };

  return data;
}

function _componentsList() {
  const data = _interopRequireDefault(require("../../../consumer/component/components-list"));

  _componentsList = function () {
    return data;
  };

  return data;
}

function _loader() {
  const data = _interopRequireDefault(require("../../../cli/loader"));

  _loader = function () {
    return data;
  };

  return data;
}

/**
 * Watch all components specified in bit.map.
 * Run buildAll for each change in the watched paths
 *
 * @export
 * @param {boolean} verbose - showing verbose output for inspection
 * @returns
 */
var _default =
/*#__PURE__*/
function () {
  var _watchAll = (0, _bluebird().coroutine)(function* (verbose) {
    // TODO: run build in the begining of process (it's work like this in other envs)
    const consumer = yield (0, _consumer().loadConsumer)();
    const componentsList = new (_componentsList().default)(consumer);
    const bitMapComponentsPaths = componentsList.getPathsForAllFilesOfAllComponents(undefined, true);

    const watcher = _chokidar().default.watch(bitMapComponentsPaths, {
      ignoreInitial: true,
      ignored: '**/dist/**'
    });

    console.log(_chalk().default.yellow('Starting watch for changes')); // eslint-disable-line no-console

    if (verbose) {
      // Print all watched paths
      bitMapComponentsPaths.forEach(path => console.log(`Watching ${path}`)); // eslint-disable-line no-console
    }

    watcher.on('change', p => {
      const log = console.log.bind(console); // eslint-disable-line no-console

      log(`File ${p} has been changed, calling build`); // TODO: Make sure the log for build is printed to console

      (0, _build().buildAll)(false, false).then(buildResult => {
        console.log(buildResult); // eslint-disable-line no-console

        _loader().default.stop();

        console.log(_chalk().default.yellow('watching for changes')); // eslint-disable-line no-console
      }).catch(err => {
        log(err); // eslint-disable-line
      });
    });
    return new Promise(() => {});
  });

  function watchAll(_x) {
    return _watchAll.apply(this, arguments);
  }

  return watchAll;
}();

exports.default = _default;